{% set type = type|default('col') %}

{# img card base setting #}
{% set display_img = img_display ?? true %}
{% set img_ratio = img_ratio|default("16:9") %}
{% set card_classes = ['news-card']|merge(card_classes|default([])) %}

{# img ratio spec #}
{% if img_ratio == "16:9" %}
    {% set card_classes = card_classes|merge(['news-card-16-9']) %}
{% elseif img_ratio == "1:1" %}
    {% set card_classes = card_classes|merge(['news-card-1']) %}
{% elseif img_ratio == "3:4" %}
    {% set card_classes = card_classes|merge(['news-card-3-4']) %}
{% elseif img_ratio == "banner" %}
    {% set card_classes = card_classes|merge(['news-card-banner']) %}
{% endif %}

{# card type spec #}
{% if type == "full" %}
    {% set card_classes = card_classes|merge(['news-card-full']) %}
{% endif %}

{% if type == "row" %}
    {% set card_classes = card_classes|merge(['news-card-row']) %}
{% endif %}

{% if type == "col" %}
    {% set card_classes = card_classes|merge(['news-card-col']) %}
{% endif %}

{% if type == "text" %}
    {% set card_classes = card_classes|merge(['news-card-only-text']) %}
{% endif %}

{# img size for full #}
{% if type == "full" %}
    {% if img_ratio == "16:9" %}
        {% set img_width = img_width|default(560) %}
        {% set img_height = img_height|default(315) %}
    {% elseif img_ratio == "1:1" %}
        {% set img_width = img_width|default(560) %}
        {% set img_height = img_height|default(560) %}
    {% elseif img_ratio == "3:4" %}
        {% set img_width = img_width|default(585) %}
        {% set img_height = img_height|default(780) %}
    {% endif %}
{% endif %}

{# img size fallback #}
{% set img_width = img_width|default(320) %}
{% set img_height = img_height|default(180) %}
{% set entity_img_size_format = img_width ~ "x" ~ img_height %}

{% set entity = entity|default(null) %}

{% if defaultArticlePageRoute is defined %}
    {% set defaultEntityLink = path(defaultArticlePageRoute, {slug: entity.slug, id: entity.id}) %}
{% else %}
    {% set defaultEntityLink = null %}
{% endif %}

{% set entity_link = entity_link|default(defaultEntityLink) %}
{% set entity_img_src = img_src|default() %}
{% set entity_headline = headline|default(entity.headline|default(null)) %}
{% set entity_title = title|default(entity.title|default(null)) %}
{% set entity_upper_title = entity_upper_title|default(null) %}
{% set entity_published_date = published_date|default(entity.publishedAt|default(null)) %}
{% set entity_has_player = player|default(entity.video|default(false)) %}

{% set label_thumbnail = labels|default(entity.labels|default([])) %}
{% set label_position = label_position|default('top') %}
{% set label_info = labels_info|default(entity.labels_info|default([])) %}

{% set date_display = date_display ?? true %}

<div class="{{ card_classes|join(' ') }}">
    <!-- news card picture -->
    {% block thumbnail %}
        {% if type != 'text' %}
            {% from '@FrontBundle/component/thumbnail.html.twig' import thumb %}
                
            {% set entity_img_size_format = img_width ~ "x" ~ img_height %}
            {% set thumb_obj = {
                figure_classes: ["news-card-picture"],
                href: type == "full" ? entity_link : null,
                picture: entity_img_src,
                width: img_width,
                height: img_height,
                alt: entity_title,
                ratio: img_ratio,
                play: entity_has_player,
                img_100: true,
                label: label_thumbnail,
                lazyload: img_lazyloaded|default(true)
            } %}

            {% if data_tracking|default('') is not empty %}
                {% set thumb_obj = thumb_obj|merge({'dataAttr': data_tracking|raw}) %}
            {% endif %}

            {{ thumb(thumb_obj) }}
        {% endif %}
    {% endblock %}

    <div class="news-card-info">
        {% block news_card_info_header %}
            {% block news_card_info_labels %}
                {% if label_info|length > 0 %}
                    <div class="news-card-label-container">
                        {% import '@FrontBundle/component/label.html.twig' as labelInit %}
                        {% for item in label_info %}
                            {{ labelInit.label(item) }}
                        {% endfor %}
                    </div>
                {% endif %}
            {% endblock %}

            {% block news_card_info_upper_title %}
                {% if entity_upper_title is not null %}
                    <span class="news-card-upper-title">{{ entity_upper_title }}</span>
                {% endif %}
            {% endblock %}
        {% endblock %}

        {% block news_card_info_body %}
            {% block news_card_info_title %}
                {% if entity_title is not null %}
                    {% if entity_link is not null  %}
                    <a href="{{ entity_link }}" class="news-card-title news-card-link">
                        {{ entity_title }}
                    </a>
                    {% else %}
                    <div class="news-card-title">
                        {{ entity_title|raw }}
                    </div>
                    {% endif %}
                {% endif %}
            {% endblock %}

            {% block news_card_info_text %}
                {% if entity_headline is not null and show_headline|default(false) %}
                    <div href="{{ entity_link }}" class="news-card-text">
                        {{ entity_headline|raw }}
                    </div>
                {% endif %}
            {% endblock %}
        {% endblock %}
        
        {% block news_card_info_footer %}
            {% block news_card_info_date %}
                {% if entity_published_date is not null and date_display == true %}
                    <div class="news-card-date">
                        {{ entity_published_date }}
                    </div>
                {% endif %}
            {% endblock %}
        {% endblock %}
    </div>
</div>